// Frame rendering with SVP shaders, based on MVFlowFps.h code
// Copyright(c)2011-2012 Chainik @forum.svp-team.com

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#ifndef __MSMOOTHFPS_H__
#define __MSMOOTHFPS_H__

#include "MVInterface.h"
#include "yuy2planes.h"
#include "libflow.h"

class MSmoothFps:public GenericVideoFilter, public MVFilter
{
public:
	MSmoothFps(PClip _child, PClip _super, PClip _mvbw, PClip _mvfw, PClip _finest,
                unsigned int _num, unsigned int _den,
                int _algo, int _ml,
                bool _block,bool _blend,
                int _sadml,double _sadgamma,
                int nSCD1, int nSCD2,
                int flags, int gpuId,
                IScriptEnvironment* env);
	~MSmoothFps();

	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);

protected:
    BYTE calcSAD(unsigned int s);

private:
	MVClip mvClipB;
	MVClip mvClipF;

	PClip finest;

	__int64 fa,fb;

	int algo;
	int flags;

	bool blendOnSceneChange;
	bool flowBlocks;
	bool applySADMask;

    HFLOWLIB hFlowLib;
    int flowLibVersion;

    fnFlowLib_Init pFlowLib_Init;
	fnFlowLib_Clear pFlowLib_Clear;
	fnFlowLib_SetTime pFlowLib_SetTime;
	fnFlowLib_Calculate pFlowLib_Calculate;

    bool ignorePel;

	int occScaleFactor;

    double sadGamma;
    double sadNormFactor;

	BYTE *VX_B,*VY_B;
	BYTE *VX_F,*VY_F;
	BYTE *VX_BB,*VY_BB;
	BYTE *VX_FF,*VY_FF;

	BYTE *OccMask_B,*OccMask_F;
	BYTE *SADMask_B,*SADMask_F;

	int nWidthUV;
	int nHeightUV;
	int	VPitchY, VPitchUV;

	int nBlkXP;
	int nBlkYP;
	int nWidthP;
	int nHeightP;
	int nWidthPUV;
	int nHeightPUV;

	int nHPaddingUV;
	int nVPaddingUV;

	YUY2Planes *DstPlanes;
};

#endif //__MSMOOTHFPS_H__

